﻿using ShellExtensions;
using System;
using System.Drawing;
using System.IO;
using System.Runtime.InteropServices;

namespace PhotoThumbnail
{
    [Guid("6f36dc76-d390-4042-b5d7-89e96e5dddc2")]
    [ComVisible(true)]
    [ClassInterface(ClassInterfaceType.None)]
    [ProgId("PhotoThumbnail.TgaThumbnailer")]
    [ThumbnailProvider("TgaThumbnailer", ".tga", ThumbnailAdornment = ThumbnailAdornment.PhotoBorder)]
    public class TgaThumbnailer : ThumbnailProvider, IThumbnailFromStream, IThumbnailFromFile
    {
        #region IThumbnailFromStream Members

        public Bitmap ConstructBitmap(Stream stream, int sideSize)
        {
            Bitmap bitmap = TgaDecoder.FromStream(stream);

            if (bitmap.Width > sideSize || bitmap.Height > sideSize)
            {
                int w = bitmap.Width;
                int h = bitmap.Height;
                if (w > sideSize)
                {
                    h = sideSize * h / w;
                    w = sideSize;
                }
                else
                {
                    w = w * sideSize / h;
                    h = sideSize;
                }
                bitmap = new Bitmap(bitmap, w, h);
            }

            return bitmap;
        }

        #endregion

        #region IThumbnailFromFile Members

        public Bitmap ConstructBitmap(FileInfo info, int sideSize)
        {
            using (FileStream stream = File.OpenRead(info.FullName))
            {
                return ConstructBitmap(stream, sideSize);
            }
        }

        #endregion
    }
}
